#include "StdAfx.h"
#include "CaptionMain.h"

CCaptionMain::CCaptionMain(void)
{
	m_iLastCounter = -1;
	m_bAnalyz = TRUE;

	m_ucVersion = 0xFF;

	m_pLangList = 0;
	m_dwLangListCount = NULL;
	m_pCapList = 0;
	m_dwCapListCount = NULL;
}

CCaptionMain::~CCaptionMain(void)
{
	for( int i=0; i<(int)m_PayloadList.size(); i++ ){
		SAFE_DELETE(m_PayloadList[i]);
	}
	m_PayloadList.clear();

	if( m_pLangList != NULL ){
		SAFE_DELETE_ARRAY(m_pLangList);
		m_dwLangListCount = 0;
	}
	if( m_pCapList != NULL ){
		for( DWORD i=0; i<m_dwCapListCount; i++ ){
			for( DWORD j=0; j<m_pCapList[i].dwListCount; j++ ){
				SAFE_DELETE(m_pCapList[i].pstCharList[j].pszDecode);
			}
			SAFE_DELETE_ARRAY(m_pCapList[i].pstCharList);
		}
		SAFE_DELETE_ARRAY(m_pCapList);
	}
}

DWORD CCaptionMain::Clear()
{
	for( int i=0; i<(int)m_PayloadList.size(); i++ ){
		SAFE_DELETE(m_PayloadList[i]);
	}
	m_PayloadList.clear();

	m_LangTagList.clear();
	m_CaptionMap.clear();
	m_ucVersion = 0xFF;

	m_iLastCounter = -1;
	m_bAnalyz = TRUE;
	return 0;
}

DWORD CCaptionMain::AddTSPacket(BYTE* pbPacket)
{
	if( pbPacket == NULL ){
		Clear();
		return FALSE;
	}
	BYTE bb[188];
	memcpy(bb,pbPacket,188);

	unsigned char ucSync = pbPacket[0];
	unsigned char ucTsErr = (pbPacket[1]&0x80)>>7;
	unsigned char ucPayloadStartFlag = (pbPacket[1]&0x40)>>6;
	unsigned char ucPriority = (pbPacket[1]&0x20)>>5;
	unsigned short usPID = ((unsigned short)(pbPacket[1]&0x1F))<<8 | pbPacket[2];
	unsigned char ucScramble = (pbPacket[3]&0xC0)>>6;
	unsigned char ucAdaptFlag = (pbPacket[3]&0x20)>>5;
	unsigned char ucPayloadFlag = (pbPacket[3]&0x10)>>4;
	unsigned char ucCounter = (pbPacket[3]&0x0F);

	if( ucSync != 0x47 ){
		Clear();
		return ERR_CAN_NOT_ANALYZ;
	}

	//pPbgJE^[`FbN
	if( m_iLastCounter == -1 ){
		m_iLastCounter = (int)ucCounter;
	}else{
		if( ucCounter == 0x00 ){
			if( m_iLastCounter != 0x0F ){
				Clear();
			}else{
				m_iLastCounter = (int)ucCounter;
			}
		}else{
			if( ucCounter != m_iLastCounter+1 ){
				Clear();
			}else{
				m_iLastCounter = (int)ucCounter;
			}
		}
	}

	unsigned char ucAdaptLength = 0;
	unsigned char ucPayloadOffset = 0;
	DWORD dwStart = 4;
	BOOL bBeforeParse = FALSE;

	//A_ve[VtB[h͔΂
	if( ucAdaptFlag == 1 ){
		ucAdaptLength = pbPacket[4];
		dwStart++;
		dwStart+=ucAdaptLength;
	}
	
	DWORD dwRet = NO_ERR;
	//yC[hH
	if( ucPayloadFlag == 1 ){
		if( ucPayloadStartFlag == 1 ){
//			ucPayloadOffset = pbPacket[dwStart];
//			dwStart++;
		}else{
			if( m_PayloadList.size() == 0 ){
				//Xgɒ܂ĂȂ̂ɊJntÔpPbgȂ
				Clear();
				return ERR_NOT_FIRST;
			}
		}
		if( ucPayloadOffset != 0 && m_PayloadList.size()>0 ){
			//ItZbgƂƂ͑Õf[^
			if( dwStart+ucPayloadOffset > 188 ){
				//TCY188ȏƂ肦Ȃ
				return ERR_INVALID_PACKET;
			}
			PAYLOAD_DATA* stData = new PAYLOAD_DATA;
			stData->wSize = ucPayloadOffset;
			memcpy(stData->bBuff, pbPacket+dwStart, stData->wSize);
			m_PayloadList.push_back(stData);
			//S܂͂Ȃ̂ŉ͍Ƃɓ

			dwRet = ParseListData();
			for( int i=0; i<(int)m_PayloadList.size(); i++ ){
				SAFE_DELETE(m_PayloadList[i]);
			}
			m_PayloadList.clear();

			if( dwRet == NO_ERR ){
				m_bAnalyz = TRUE;
				bBeforeParse = TRUE;
			}
		}
		dwStart+=ucPayloadOffset;

		if( (m_bAnalyz == FALSE || dwStart > 188) && (ucPayloadStartFlag == 1)){
			//͂ĂȂ̂Ɏ̊JnpPbg
			//pPbgł\̂ŃG[
			Clear();
			return ERR_INVALID_PACKET;
		}
		if( dwStart >= 188 ){
			//A_ve[VŃyC[hȂȂH
			Clear();
			return dwRet;
		}
		m_bAnalyz = FALSE;

		//Ƃ肠f[^Xgɓ˂
		PAYLOAD_DATA* stData = new PAYLOAD_DATA;
		stData->wSize = (WORD)(188-dwStart);
		memcpy(stData->bBuff,pbPacket+dwStart, stData->wSize);
		m_PayloadList.push_back(stData);

		BOOL bNext = TRUE;
		if( ucPayloadStartFlag == 1 ){
			//X^[gtOĂ̂łꂾŃf[^܂Ă邩`FbN
			m_dwNowReadSize = 0;
			m_dwNeedSize = 0;
			while( m_dwNowReadSize+3<stData->wSize){
				if( stData->bBuff[0] != 0x00 || 
					stData->bBuff[1] != 0x00 || 
					stData->bBuff[2] != 0x01 ){
					//PESȂ̂ŃG[
					Clear();
					return ERR_INVALID_PACKET;
				}
				
				DWORD dwSecSize = 0;
				dwSecSize += (((DWORD)(stData->bBuff[4]))<<8 | stData->bBuff[5])+6;
				m_dwNeedSize += dwSecSize;
				if( stData->wSize < m_dwNeedSize ){
					m_dwNowReadSize = stData->wSize;
				}else{
					m_dwNowReadSize += dwSecSize;
				}

				//܂H
				if( m_dwNeedSize<stData->wSize ){
					if( stData->bBuff[m_dwNeedSize] == 0xFF ){
						//NULLf[^
						bNext = FALSE;
						break;
					}
				}
			}
		}else{
			m_dwNowReadSize += stData->wSize;
		}

		if( m_dwNeedSize <= m_dwNowReadSize || bNext == FALSE){
			//S܂̂ŉ͍Ƃɓ
			dwRet = ParseListData();
			for( int i=0; i<(int)m_PayloadList.size(); i++ ){
				SAFE_DELETE(m_PayloadList[i]);
			}
			m_PayloadList.clear();
		}else{

			if( bBeforeParse == TRUE ){
				dwRet = TRUE;
				goto CREATE_DATA;
			}

			return ERR_NEED_NEXT_PACKET;
		}
	}

	if( dwRet == NO_ERR || dwRet>=20){
		m_bAnalyz = TRUE;
	}
CREATE_DATA:

	return dwRet;
}

DWORD CCaptionMain::ParseListData()
{
	//܂obt@
	BYTE* pbBuff = NULL;
	DWORD dwBuffSize = 0;
	for( int i=0; i<(int)m_PayloadList.size();i++){
		dwBuffSize += m_PayloadList[i]->wSize;
	}
	pbBuff = new BYTE[dwBuffSize];
	DWORD dwReadBuff = 0;
	for( int i=0; i<(int)m_PayloadList.size();i++){
		memcpy( pbBuff+dwReadBuff, m_PayloadList[i]->bBuff, m_PayloadList[i]->wSize );
		dwReadBuff+=m_PayloadList[i]->wSize;
	}

	WORD wPesSize = ((WORD)(pbBuff[4]))<<8 | pbBuff[5];
	WORD wHeadSize = pbBuff[8];
	WORD wDataSize = wPesSize-wHeadSize-3;
	WORD wStartPos = 8+wHeadSize+1;
	
	DWORD dwRet = ParseCaption(pbBuff+wStartPos, wDataSize);

	delete[] pbBuff;

	return dwRet;
}

DWORD CCaptionMain::ParseCaption(BYTE* pbBuff, DWORD dwSize)
{
	if( pbBuff == NULL || dwSize < 3 ){
		return ERR_INVALID_PACKET;
	}
	if( pbBuff[0] != 0x80 && pbBuff[0] != 0x81 ){
		return ERR_INVALID_PACKET;
	}
	if( pbBuff[1] != 0xFF ){
		return ERR_INVALID_PACKET;
	}
	unsigned char ucHeadSize = pbBuff[2]&0x0F;
	
	DWORD dwStartPos = 3+ucHeadSize;

	unsigned char ucDataGroupID = pbBuff[dwStartPos]>>2;
	unsigned char ucVersion = pbBuff[dwStartPos]&0x03;
	dwStartPos+=3;
	unsigned short usDataGroupSize = ((unsigned short)(pbBuff[dwStartPos]))<<8 | pbBuff[dwStartPos+1];
	dwStartPos+=2;

	BOOL bChg = FALSE;
	if( ucVersion != m_ucVersion ){
		m_LangTagList.clear();
		m_ucVersion = ucVersion;
		bChg = TRUE;
	}
	
	DWORD dwRet = NO_ERR;
	if( ucDataGroupID == 0x00 || ucDataGroupID == 0x20 ){
		//Ǘ
		vector<CAPTION_DATA> CaptionList;
		dwRet = ParseCaptionManagementData(pbBuff+dwStartPos,usDataGroupSize-2, &CaptionList);
		if( CaptionList.size() > 0 ){
			InsertCaptionList(ucDataGroupID,&CaptionList);
		}
		if( dwRet == NO_ERR ){
			dwRet = NO_ERR_TAG_INFO;
		}
	}else{
		//f[^
		vector<CAPTION_DATA> CaptionList;
		dwRet = ParseCaptionData(pbBuff+dwStartPos,usDataGroupSize-2, &CaptionList);
		if( CaptionList.size() > 0 ){
			InsertCaptionList(ucDataGroupID,&CaptionList);
		}
		if( dwRet == NO_ERR ){
			dwRet = NO_ERR_CAPTION;
		}
	}
	if( bChg == TRUE ){
		return CHANGE_VERSION;
	}else{
		return dwRet;
	}
}


DWORD CCaptionMain::ParseCaptionManagementData(BYTE* pbBuff, DWORD dwSize, vector<CAPTION_DATA>* pCaptionList)
{
	if( pbBuff == NULL ){
		return ERR_INVALID_PACKET;
	}
	DWORD dwRet = NO_ERR;
	
	DWORD dwPos = 0;
	unsigned char ucTMD = pbBuff[dwPos]>>6;
	dwPos++;
	unsigned char ucOTMHH = 0;
	unsigned char ucOTMMM = 0;
	unsigned char ucOTMSS = 0;
	unsigned char ucOTMSSS = 0;
	if( ucTMD == 0x02 ){
		//OTM
		ucOTMHH = (pbBuff[dwPos]&0xF0>>4)*10 + (pbBuff[dwPos]&0x0F);
		dwPos++;
		ucOTMMM = (pbBuff[dwPos]&0xF0>>4)*10 + (pbBuff[dwPos]&0x0F);
		dwPos++;
		ucOTMSS = (pbBuff[dwPos]&0xF0>>4)*10 + (pbBuff[dwPos]&0x0F);
		dwPos++;
		ucOTMSSS = (pbBuff[dwPos]&0xF0>>4)*100 + (pbBuff[dwPos]&0x0F)*10 + (pbBuff[dwPos+1]&0xF0>>4);
		dwPos+=2;
	}
	unsigned char ucLangNum = pbBuff[dwPos];
	dwPos++;
	
	for( unsigned char i=0; i<ucLangNum; i++ ){
		LANG_TAG_INFO Item;
		Item.ucLangTag = pbBuff[dwPos]>>5;
		Item.ucDMF = pbBuff[dwPos]&0x0F;
		dwPos++;
		if( Item.ucDMF == 0x0C || Item.ucDMF == 0x0D || Item.ucDMF == 0x0E ){
			Item.ucDC = pbBuff[dwPos];
			dwPos++;
		}
		Item.szISOLangCode[0] = pbBuff[dwPos];
		Item.szISOLangCode[1] = pbBuff[dwPos+1];
		Item.szISOLangCode[2] = pbBuff[dwPos+2];
		Item.szISOLangCode[3] = 0x00;
		dwPos+=3;
		Item.ucFormat = pbBuff[dwPos]>>4;
		Item.ucTCS = (pbBuff[dwPos]&0x0C)>>2;
		Item.ucRollupMode = pbBuff[dwPos]&0x03;
		dwPos++;

		m_LangTagList.insert(pair<WORD, LANG_TAG_INFO>((WORD)Item.ucLangTag,Item));
	}
	UINT uiUnitSize = ((UINT)(pbBuff[dwPos]))<<16 | ((UINT)(pbBuff[dwPos+1]))<<8 | pbBuff[dwPos+2];
	dwPos+=3;
	if( uiUnitSize > 0 ){
		//f[^
		DWORD dwReadSize = 0;
		while(dwReadSize<uiUnitSize){
			DWORD dwSize = 0;
			dwRet = ParseUnitData(pbBuff+dwPos+dwReadSize, uiUnitSize-dwReadSize,&dwSize, pCaptionList);
			dwReadSize+=dwSize;
		}
	}
	return dwRet;
}

DWORD CCaptionMain::ParseCaptionData(BYTE* pbBuff, DWORD dwSize, vector<CAPTION_DATA>* pCaptionList)
{
	if( pbBuff == NULL ){
		return ERR_INVALID_PACKET;
	}
	
	DWORD dwRet = NO_ERR;
	
	DWORD dwPos = 0;
	unsigned char ucTMD = pbBuff[dwPos]>>6;
	dwPos++;

	unsigned char ucOTMHH = 0;
	unsigned char ucOTMMM = 0;
	unsigned char ucOTMSS = 0;
	unsigned char ucOTMSSS = 0;
	
	if( ucTMD == 0x01 || ucTMD == 0x02 ){
		//STM
		ucOTMHH = (pbBuff[dwPos]&0xF0>>4)*10 + (pbBuff[dwPos]&0x0F);
		dwPos++;
		ucOTMMM = (pbBuff[dwPos]&0xF0>>4)*10 + (pbBuff[dwPos]&0x0F);
		dwPos++;
		ucOTMSS = (pbBuff[dwPos]&0xF0>>4)*10 + (pbBuff[dwPos]&0x0F);
		dwPos++;
		ucOTMSSS = (pbBuff[dwPos]&0xF0>>4)*100 + (pbBuff[dwPos]&0x0F)*10 + (pbBuff[dwPos+1]&0xF0>>4);
		dwPos+=2;
	}
	UINT uiUnitSize = ((UINT)(pbBuff[dwPos]))<<16 | ((UINT)(pbBuff[dwPos+1]))<<8 | pbBuff[dwPos+2];
	dwPos+=3;
	if( uiUnitSize > 0 ){
		//f[^
		DWORD dwReadSize = 0;
		while(dwReadSize<uiUnitSize){
			DWORD dwSize = 0;
			dwRet = ParseUnitData(pbBuff+dwPos+dwReadSize, uiUnitSize-dwReadSize,&dwSize, pCaptionList);
			dwReadSize+=dwSize;
		}

	}
	return dwRet;
}

DWORD CCaptionMain::ParseUnitData(BYTE* pbBuff, DWORD dwSize, DWORD* pdwReadSize, vector<CAPTION_DATA>* pCaptionList)
{
	if( pbBuff == NULL || dwSize < 5 || pdwReadSize == NULL ){
		return FALSE;
	}
	if( pbBuff[0] != 0x1F ){
		return FALSE;
	}
	if( pbBuff[1] != 0x20 ){
		//ȊO͖T|[g
		*pdwReadSize = dwSize;
		return FALSE;
	}
	UINT uiUnitSize = ((UINT)(pbBuff[2]))<<16 | ((UINT)(pbBuff[3]))<<8 | pbBuff[4];
	
	if( uiUnitSize > 0 ){
		CARIB8CharDecode cDec;
		cDec.Caption(pbBuff+5, uiUnitSize, pCaptionList);
	}
	*pdwReadSize = 5+uiUnitSize;

	return TRUE;
}

BOOL CCaptionMain::InsertCaptionList(WORD wGroupID, vector<CAPTION_DATA>* pCaptionList)
{
	WORD wID = wGroupID&0x0F;
	map<WORD, CAPTION_LIST>::iterator itr;
	itr  = m_CaptionMap.find(wID);
	if( itr != m_CaptionMap.end() ){
		m_CaptionMap.erase(itr);
	}
	CAPTION_LIST Item;
	Item.wGroupID = wID;
	Item.CaptionList = *pCaptionList;
	m_CaptionMap.insert(pair<WORD, CAPTION_LIST>(wID, Item));
	return TRUE;
}

DWORD CCaptionMain::GetTagInfo(vector<CCaptionMain::LANG_TAG_INFO>* pList)
{
	map<WORD, LANG_TAG_INFO>::iterator itr;
	for( itr = m_LangTagList.begin(); itr != m_LangTagList.end(); itr++ ){
		pList->push_back(itr->second);
	}
	return TRUE;
}

DWORD CCaptionMain::GetCaptionData(unsigned char ucLangTag, vector<CAPTION_DATA>* pList)
{
	map<WORD, CAPTION_LIST>::iterator itr;
	itr = m_CaptionMap.find(ucLangTag+1);
	if( itr != m_CaptionMap.end() ){
		*pList = itr->second.CaptionList;
	}
	return TRUE;
}

DWORD CCaptionMain::GetTagInfo(LANG_TAG_INFO_DLL** ppList, DWORD* pdwListCount)
{
	if( m_pLangList != NULL ){
		SAFE_DELETE_ARRAY(m_pLangList);
		m_dwLangListCount = 0;
	}
	if( ppList == NULL || pdwListCount == NULL ){
		return FALSE;
	}
	vector<CCaptionMain::LANG_TAG_INFO> List;
	DWORD dwRet = GetTagInfo(&List);
	if( List.size() > 0 ){
		m_dwLangListCount = (DWORD)List.size();
		m_pLangList = new LANG_TAG_INFO_DLL[m_dwLangListCount];
		for( int i=0; i<(int)List.size(); i++ ){
			m_pLangList[i].ucLangTag=List[i].ucLangTag;
			m_pLangList[i].ucDMF = List[i].ucDMF;
			m_pLangList[i].ucDC = List[i].ucDC;
			memcpy(m_pLangList[i].szISOLangCode, List[i].szISOLangCode, 4 );
			m_pLangList[i].ucFormat = List[i].ucFormat;
			m_pLangList[i].ucTCS = List[i].ucTCS;
			m_pLangList[i].ucRollupMode = List[i].ucRollupMode;
		}
		*pdwListCount = m_dwLangListCount;
		*ppList = m_pLangList;
	}else{
		return FALSE;
	}
	return dwRet;
}

DWORD CCaptionMain::GetCaptionData(unsigned char ucLangTag, CAPTION_DATA_DLL** ppList, DWORD* pdwListCount)
{
	if( m_pCapList != NULL ){
		for( DWORD i=0; i<m_dwCapListCount; i++ ){
			for( DWORD j=0; j<m_pCapList[i].dwListCount; j++ ){
				SAFE_DELETE(m_pCapList[i].pstCharList[j].pszDecode);
			}
			SAFE_DELETE_ARRAY(m_pCapList[i].pstCharList);
		}
		SAFE_DELETE_ARRAY(m_pCapList);
		m_dwCapListCount = 0;
	}
	if( ppList == NULL || pdwListCount == NULL ){
		return FALSE;
	}

	vector<CAPTION_DATA> List;
	DWORD dwRet = GetCaptionData(ucLangTag, &List);
	if( List.size() > 0 ){
		m_dwCapListCount = (DWORD)List.size();
		m_pCapList = new CAPTION_DATA_DLL[m_dwCapListCount];
		for( int i=0; i<(int)List.size(); i++ ){
			m_pCapList[i].dwListCount = (DWORD)List[i].CharList.size();
			m_pCapList[i].pstCharList = new CAPTION_CHAR_DATA_DLL[m_pCapList[i].dwListCount];
			for( int j=0; j<(int)List[i].CharList.size(); j++ ){
				if( List[i].CharList[j].strDecode.length() > 0 ){
					m_pCapList[i].pstCharList[j].pszDecode = new char[List[i].CharList[j].strDecode.length()+1];
					ZeroMemory(m_pCapList[i].pstCharList[j].pszDecode, List[i].CharList[j].strDecode.length()+1);
					strcpy_s(m_pCapList[i].pstCharList[j].pszDecode, List[i].CharList[j].strDecode.length()+1, List[i].CharList[j].strDecode.c_str());
				}else{
					m_pCapList[i].pstCharList[j].pszDecode = NULL;
				}

				m_pCapList[i].pstCharList[j].wCharSizeMode = (DWORD)List[i].CharList[j].emCharSizeMode;
				m_pCapList[i].pstCharList[j].stCharColor.ucAlpha = List[i].CharList[j].stCharColor.ucAlpha;
				m_pCapList[i].pstCharList[j].stCharColor.ucB = List[i].CharList[j].stCharColor.ucB;
				m_pCapList[i].pstCharList[j].stCharColor.ucG = List[i].CharList[j].stCharColor.ucG;
				m_pCapList[i].pstCharList[j].stCharColor.ucR = List[i].CharList[j].stCharColor.ucR;
				m_pCapList[i].pstCharList[j].stBackColor.ucAlpha = List[i].CharList[j].stBackColor.ucAlpha;
				m_pCapList[i].pstCharList[j].stBackColor.ucB = List[i].CharList[j].stBackColor.ucB;
				m_pCapList[i].pstCharList[j].stBackColor.ucG = List[i].CharList[j].stBackColor.ucG;
				m_pCapList[i].pstCharList[j].stBackColor.ucR = List[i].CharList[j].stBackColor.ucR;
				m_pCapList[i].pstCharList[j].stRasterColor.ucAlpha = List[i].CharList[j].stRasterColor.ucAlpha;
				m_pCapList[i].pstCharList[j].stRasterColor.ucB = List[i].CharList[j].stRasterColor.ucB;
				m_pCapList[i].pstCharList[j].stRasterColor.ucG = List[i].CharList[j].stRasterColor.ucG;
				m_pCapList[i].pstCharList[j].stRasterColor.ucR = List[i].CharList[j].stRasterColor.ucR;
				m_pCapList[i].pstCharList[j].bUnderLine = List[i].CharList[j].bUnderLine;
				m_pCapList[i].pstCharList[j].bShadow = List[i].CharList[j].bShadow;
				m_pCapList[i].pstCharList[j].bBold = List[i].CharList[j].bBold;
				m_pCapList[i].pstCharList[j].bItalic = List[i].CharList[j].bItalic;
				m_pCapList[i].pstCharList[j].bFlushMode = List[i].CharList[j].bFlushMode;
				m_pCapList[i].pstCharList[j].wCharW = List[i].CharList[j].wCharW;
				m_pCapList[i].pstCharList[j].wCharH = List[i].CharList[j].wCharH;
				m_pCapList[i].pstCharList[j].wCharHInterval = List[i].CharList[j].wCharHInterval;
				m_pCapList[i].pstCharList[j].wCharVInterval = List[i].CharList[j].wCharVInterval;
			}

			m_pCapList[i].bClear=List[i].bClear;
			m_pCapList[i].wSWFMode = List[i].wSWFMode;
			m_pCapList[i].wClientX = List[i].wClientX;
			m_pCapList[i].wClientY = List[i].wClientY;
			m_pCapList[i].wClientW = List[i].wClientW;
			m_pCapList[i].wClientH = List[i].wClientH;
			m_pCapList[i].wPosX = List[i].wPosX;
			m_pCapList[i].wPosY = List[i].wPosY;
			m_pCapList[i].dwWaitTime = List[i].dwWaitTime;
		}
		*pdwListCount = m_dwCapListCount;
		*ppList = m_pCapList;
	}else{
		return FALSE;
	}
	return dwRet;
}
