#include "stdafx.h"
#include "CommRoutine.h"
#include <strsafe.h>
#include <map>
using namespace std;

char HiraTable[][3]={
	"","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","@","@","@","T",
	"U","[","B","u","v","A","E",
	"I","h","","","","","f",
	"i","j","","{","C","|","D","^",
	"O","P","Q","R","S","T","U","V",
	"W","X","F","G","","","","H",
	"","`","a","b","c","d","e","f",
	"g","h","i","j","k","l","m","n",
	"o","p","q","r","s","t","u","v",
	"w","x","y","m","","n","O","Q",
	"e","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","o","b","p","P"
};

char HalfHiraTable[][3]={
	"","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","",""," "," "," ","T",
	"U","","","","","","",
	"!","\"","#","$","%","&","'",
	"(",")","*","+",",","-",".","/",
	"0","1","2","3","4","5","6","7",
	"8","9",":",";","<","=",">","?",
	"@","A","B","C","D","E","F","G",
	"H","I","J","K","L","M","N","O",
	"P","Q","R","S","T","U","V","W",
	"X","Y","Z","[","","]","^","_",
	"`","a","b","c","d","e","f","g",
	"h","i","j","k","l","m","n","o",
	"p","q","r","s","t","u","v","w",
	"x","y","z","{","|","}","P"
};

char KanaTable[][3]={
	"@","A","B","C","D","E","F",
	"G","H","I","J","K","L","M","N",
	"O","P","Q","R","S","T","U","V",
	"W","X","Y","Z","[","\","]","^",
	"_","`","a","b","c","d","e","f",
	"g","h","i","j","k","l","m","n",
	"o","p","q","r","s","t","u","v",
	"w","x","y","z","{","|","}","~",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","R",
	"S","[","B","u","v","A","E"
};

char HalfKanaTable[][3]={
	"","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","",
	"","","","","","","","R",
	"S","","","","","",""
};

#ifdef _DEBUG
VOID
DbgString(
	IN	LPCTSTR tracemsg,
	...
	)
{
	TCHAR buf[MAX_DEBUG_OUTPUT_LENGTH] = {0};
	HRESULT ret;

	__try {
		va_list ptr;
		va_start(ptr,tracemsg);

		ret = StringCchVPrintf(
			buf,
			2048,
			tracemsg,
			ptr
			);

		if(ret == S_OK) {
			OutputDebugString(buf);
		}
	}
	__finally {
	}

	return;
}
#endif

std::string GetHalfChar(std::string key)
{
	std::string ret;
	BOOL bMatch = FALSE;
	const char * _p = key.c_str();
	char * p = (char *)key.c_str();

	for(int i = 0; i < sizeof(HiraTable)/sizeof(HiraTable[0]) && p < _p + key.size(); i++) {
		if(memcmp(p, HiraTable[i], 2) == 0) {
			ret += HalfHiraTable[i];
			p+=2;
			bMatch = TRUE;
			i = -1;
		}
	}

	for(int i = 0; i < sizeof(KanaTable)/sizeof(KanaTable[0]) && p < _p + key.size(); i++) {
		if(memcmp(p, KanaTable[i], 2) == 0) {
			ret += HalfKanaTable[i];
			p+=2;
			bMatch = TRUE;
			i = -1;
		}
	}

	if(!bMatch)
		ret = key;

	return ret;
}